/*		 ITI-FG  Kernel module free public release
 *
 *		     Copyright (C) 1996-2000 GOM mbH.
 *	         Rebenring 33, 38106 Braunschweig, GERMANY
 *		            All rights reserved
 *
 *
 * $Id: itifgOS.h,v 7.0.2.2 2000/12/18 13:24:17 cvs Exp $
 *
 */

#ifndef _ITIFGOS_H
#define _ITIFGOS_H

/*
 * Includes:
 */

/* #undef linux */
#undef OS_DEFINED

#ifdef linux
#  define OS_DEFINED
#  include <linux/types.h>	/* all kernel data types */
#  include <linux/string.h>	/* memcpy, memset, ... */
#  include <linux/kernel.h>	/* printk */
#  include <linux/errno.h>	/* ENXIO, EINVAL, ... */
#  include <linux/version.h>	/* LINUX_VERSION_CODE */
#  include <linux/malloc.h>	/* kmalloc */
#  include <linux/wrapper.h>	/* mem_map_reserve */
#  include <linux/time.h>	/* do_gettimeofday */
#  include <linux/timer.h>	/* timer_list */
#  include <linux/wait.h>	/* wait_queue */
#  include <linux/sched.h>	/* task_struct */
#  include <linux/tqueue.h>	/* tq_struct */
#  include <linux/interrupt.h>	/* mark_bh */
#  include <linux/signal.h>	/* SIGIO */
#  include <linux/mm.h>		/* vremap, PAGE_SIZE */
#  include <linux/kdev_t.h>	/* MAJOR / MINOR */
#  include <linux/major.h>	/* MAX_CHRDEV */
#  include <linux/delay.h>	/* udelay */
#  include <linux/pci.h>	/* pci specific stuff */
#  include <linux/proc_fs.h>	/* proc filesystem defines */
#  include <asm/irq.h>		/* enable_irq */
#  include <asm/io.h>		/* readl, outb... */
#  include <asm/pgtable.h>	/* pgd/pme/pte_offset */
#  if LINUX_VERSION_CODE < 0x020100
#    include <asm/segment.h>	/* memcpy_tofs */
#    include <linux/bios32.h>	/* pci bios access routines */
#  elif LINUX_VERSION_CODE >= 0x020200
#    include <asm/spinlock.h>	/* spinlock_t */
#    include <linux/poll.h>	/* poll_table */
#    include <linux/vmalloc.h>	/* vmalloc */ 
#    include <asm/uaccess.h>	/* copy_to_user */
#  endif
#endif

#ifdef __NetBSD__
#  define OS_DEFINED
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/conf.h>
#include <sys/kernel.h>		/* global variables */
#include <sys/signalvar.h>
#include <sys/mman.h>
#include <sys/poll.h>
#include <sys/select.h>
#include <sys/vnode.h>		/* struct vnode */
#include <sys/malloc.h>		/* malloc/free */

#include <vm/vm.h>		/* complete vm subsystem */

#include <vm/vm_kern.h>
#include <vm/pmap.h>
#include <vm/vm_extern.h>	/* external vm inerfaces */

#include <sys/device.h>
#include <dev/pci/pcivar.h>
#include <dev/pci/pcireg.h>	/* PCI_MAPREG_... */
#include <dev/pci/pcidevs.h>	/* PCI_VENDOR_IMAGINGTECH */

#  include <sys/types.h>	/* all kernel data types */
#  include <sys/errno.h>	/* ENXIO, EINVAL, ... */
#  include <sys/time.h>		/* struct timeval */
#  include <sys/file.h>		/* struct file */
#  include <sys/param.h>	/* parameters */
#  include <sys/ioccom.h>	/* IOR/IOW/IOWR */

#if (0)
#  include <uvm/uvm.h>		/* complete uvm subsystem */
#  include <uvm/uvm_extern.h>	/* complete uvm subsystem */
#endif
#endif

/*
 * Defines:
 */

#ifdef linux
#  define ITI_PCI_BASE_ADDR_SPACE		PCI_BASE_ADDRESS_SPACE
#  define ITI_PCI_BASE_ADDR_SPACE_MEMORY	PCI_BASE_ADDRESS_SPACE_MEMORY
#  define ITI_PCI_BASE_ADDR_SPACE_IO		PCI_BASE_ADDRESS_SPACE_IO
#  define ITI_PCI_BASE_ADDR_MEM_MASK		PCI_BASE_ADDRESS_MEM_MASK
#  define ITI_PCI_BASE_ADDR_IO_MASK		PCI_BASE_ADDRESS_IO_MASK
#  define ITI_PCI_VENDOR_ID_IMAGINGTECH		PCI_VENDOR_ID_IMAGINGTECH
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ICPCI	PCI_DEVICE_ID_IMAGINGTECH_ICPCI
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ASYNC	0x0003 /* not defined yet */
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_PCDIG	0x0004 /* not defined yet */
#  if LINUX_VERSION_CODE < 0x020100
#    define ITI_SEL_IN	SEL_IN
#    define ITI_SEL_EX	SEL_EX
#  elif LINUX_VERSION_CODE >= 0x020200
#    define ITI_SEL_IN	001
#    define ITI_SEL_EX	004
#  endif
#  define ITI_MAJOR	60	/* major device number of fg board -
				   first entry for local (experimental) use */
#  define LOG_STRING	"itifg[%c]: "
#  define DEV_STRING	"itifg"
#  define IRQ_STRING	"itifg"
/* don't forget to edit the PFS_STRING in itifgExt.h */
#  define F_FLAGS(file)	(file->f_flags)
#  define OS_RELEASE	UTS_RELEASE
#  if LINUX_VERSION_CODE < 0x020100
#  define TIME_F	"%d"
#  define LOFF_F	"%ld"
#  elif LINUX_VERSION_CODE >= 0x020200
#  define TIME_F	"%ld"
#  define LOFF_F	"%Ld"
#  endif
#  if defined(__i386__)
#    define SIZE_F	"%d"
#  elif defined(__powerpc__) || defined(__alpha__)
#    define SIZE_F	"%ld"
#  elif defined(__ia64__)
#    define SIZE_F	"%Ld"
#  else
#    define SIZE_F	"%d"
#  endif
#endif

#ifdef __NetBSD__
#  define ENODATA	ETIMEDOUT	/* No data available */
#  define ITI_PCI_BASE_ADDR_SPACE		PCI_MAPREG_TYPE_MASK
#  define ITI_PCI_BASE_ADDR_SPACE_MEMORY	PCI_MAPREG_TYPE_MEM
#  define ITI_PCI_BASE_ADDR_SPACE_IO		PCI_MAPREG_TYPE_IO
#  define ITI_PCI_BASE_ADDR_MEM_MASK		PCI_MAPREG_MEM_ADDR_MASK
#  define ITI_PCI_BASE_ADDR_IO_MASK		PCI_MAPREG_IO_ADDR_MASK
#  define ITI_PCI_VENDOR_ID_IMAGINGTECH		PCI_VENDOR_IMAGINGTECH
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ICPCI	0x0000 /* not defined yet */
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ASYNC	0x0003 /* not defined yet */
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_PCDIG	0x0004 /* not defined yet */
#  define ITI_SEL_IN	001
#  define ITI_SEL_EX	004
#  define F_FLAGS(file)	(file->f_flag)
#  define OS_RELEASE	"1.4.2"	/* FIXME */
#  define HZ		hz	/* global variable */
#  define TIME_F	"%ld"
#  define LOFF_F	"%ld"
#  define SIZE_F	"%ld"
#  define ITIFGPRI	(PZERO+8)|PCATCH
#  define ITIFGIPL	IPL_BIO
#  define LOG_STRING	"itifg[%c]: "
#endif

#ifndef OS_DEFINED /* if nothing is defined, fallback */
#  define EINTR	 	1	/* Interrupted system call */
#  define EIO	 	2	/* I/O error */
#  define ENXIO	 	3	/* No such device or address */
#  define EBADF	 	4	/* Bad file number */
#  define EAGAIN	5	/* Try again */
#  define ENOMEM	6	/* Out of memory */
#  define EFAULT	7	/* Bad address */
#  define EBUSY	 	8	/* Device or resource busy */
#  define EINVAL	9	/* Invalid argument */
#  define EFBIG		10	/* File too large */
#  define ESPIPE	11	/* Illegal seek */
#  define ENODATA	12	/* No data available */
#  define PAGE_SIZE	(1 << 12)	/* 4kB */
#  define HZ		100		/* 10ms */
#  define O_RDONLY	001
#  define O_WRONLY	002
#  define O_RDWR	003
#  define O_ACCMODE	003
#  define O_EXCL	010
#  define O_NONBLOCK	020
#  define ITI_PCI_BASE_ADDR_SPACE		0x01
#  define ITI_PCI_BASE_ADDR_SPACE_MEMORY	0x00
#  define ITI_PCI_BASE_ADDR_SPACE_IO		0x01
#  define ITI_PCI_BASE_ADDR_MEM_MASK		(~0x0fUL)
#  define ITI_PCI_BASE_ADDR_IO_MASK		(~0x03UL)
#  define ITI_PCI_VENDOR_ID_IMAGINGTECH		0x112f
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ICPCI	0x0000
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_ASYNC	0x0003
#  define ITI_PCI_DEVICE_ID_IMAGINGTECH_PCDIG	0x0004
#  define ITI_SEL_IN	001
#  define ITI_SEL_EX	004
#  define ITI_MAJOR_0	0
#  define ITI_MAJOR_1	1
#  define LOG_STRING	"itifg[%d%c]: "
#  define F_FLAGS(file)	(file->f_flags)
#  define OS_RELEASE	"unknown"
#  define TIME_F	"%ld"
#  define LOFF_F	"%ld"
#  define SIZE_F	"%ld"
#endif

/*
 * Typedefs:
 */

#ifdef linux
#  if LINUX_VERSION_CODE < 0x020100
typedef off_t iti_loff_t;
typedef int iti_ssize_t;
#  elif LINUX_VERSION_CODE >= 0x020200
typedef loff_t iti_loff_t;
typedef ssize_t iti_ssize_t;
#  endif
typedef struct file iti_file_t;
typedef struct inode iti_inode_t;
typedef kdev_t iti_dev_t;
#endif

#ifdef __NetBSD__
typedef off_t iti_loff_t;
typedef ssize_t iti_ssize_t;
typedef struct file iti_file_t;
typedef struct inode iti_inode_t;
typedef dev_t iti_dev_t;
#endif

#ifndef OS_DEFINED /* if nothing is defined, fallback */
#  define u_char	unsigned char
#  define u_short	unsigned short
#  define u_long	unsigned long
#  define u_int		unsigned int
typedef long off_t;
typedef u_long ssize_t;

typedef long time_t;

typedef int size_t;
typedef char* caddr_t;

typedef off_t iti_loff_t;
typedef ssize_t iti_ssize_t;

struct timeval
{
  time_t tv_sec;
  time_t tv_usec;
};
typedef struct
{
  u_long f_flags;
} iti_file_t;

typedef void* iti_inode_t;
typedef int iti_dev_t;
#endif

/* os private structure */
struct iti_osp_t
{
#ifdef linux
  u_long flags;		/* for the inline splhigh / spllow routines */
#  if LINUX_VERSION_CODE >= 0x020200
  u_long before;
  spinlock_t spin_lock;	/* smp locking of the irq/timer function not in 2.0 */
  u_long after;
#  endif
#  if LINUX_VERSION_CODE < 0x020300
  struct wait_queue *cam_w_queue;	/* queue to wait for camera blocks */
  struct wait_queue *iop_w_queue;	/* queue to wait for io-port events */
  struct wait_queue *cam_s_queue;	/* queue to wait for camera selects */
#  elif LINUX_VERSION_CODE >= 0x020400
  wait_queue_head_t cam_w_queue;	/* queue to wait for camera blocks */
  wait_queue_head_t iop_w_queue;	/* queue to wait for io-port events */
  wait_queue_head_t cam_s_queue;	/* queue to wait for camera selects */
#  endif
  /* somebody is waiting on this queue */
  int cam_w_wait, iop_w_wait, cam_s_wait;
  struct timer_list cam_timer;	/* timeout for camera wait queues */
  struct timer_list iop_timer;	/* timeout for io-port wait queues */
  struct fasync_struct *cam_a_queue;	/* queue for send SIGIO events */ 
  struct tq_struct clr_t_queue;	/* struct to add the mem clear bottom half */
#  if LINUX_VERSION_CODE < 0x020100
  int signum;	/* signal to send on i/o completion */
#    if LINUX_VERSION_CODE < 0x020020	/* 2.0.32 */
  int pid;	/* send this signal to pid # */	
#    else
  struct fown_struct fown;
#    endif
#  else
  struct fown_struct fown;
#  endif
  struct task_struct *task;
#endif

#ifdef __NetBSD__
  int s;	/* for the various spl routines */
  /* somebody is waiting on this channel */
  int cam_w_wait, iop_w_wait, cam_s_wait;
  struct selinfo cam_s_queue;	/* queue to wait for camera selects */
  /* register/memory remapping stuff */
  bus_space_tag_t	icrt, crt, modt, memt;
  bus_space_handle_t	icrh, crh, modh, memh;
  bus_size_t		mems;
  void *ih; /* interrupt handle */
#endif
};

/*
 * Prototypes:
 */
int
iti_printd (const char*);	/* Debug */
int
iti_printda (const char*, ...);	/* Debug + Argument */
int
iti_printi (const char*);	/* Info */
int
iti_printia (const char*, ...);	/* Info + Argument */
int
iti_printn (const char*);	/* Notice */
int
iti_printna (const char*, ...);	/* Notice + Argument */
int
iti_printw (const char*);	/* Warn */
int
iti_printwa (const char*, ...);	/* Warn + Argument */
int
iti_printe (const char*);	/* Error */
int
iti_printea (const char*, ...);	/* Error + Argument */
int
iti_printr (const char*);	/* Raw */
int
iti_printra (const char*, ...);	/* Raw + Argument */

u_short
iti_readw (u_short*);
void
iti_writew (u_short, u_short*);
u_long
iti_readl (u_long*);
void
iti_writel (u_long, u_long*);
u_short
iti_inw (u_short);
void
iti_outw (u_short, u_short);
u_long
iti_inl (u_short);
void
iti_outl (u_long, u_short);
void*
iti_memset_io (void*, int, size_t);
int
iti_copyout (void*, void*, size_t);
int
iti_copyin (void*, const void*, size_t);
void
iti_udelay (u_long);

void*
iti_memcpy (void*, const void*, size_t);
void*
iti_memset (void*, int, size_t);
char*
iti_strcpy (char*, const char*);
int
iti_strcmp (const char*, const char*);

#ifdef linux
#  define iti_printd(fmt) \
	printk (KERN_DEBUG LOG_STRING fmt, 'D')
#  define iti_printda(fmt,args...) \
	printk (KERN_DEBUG LOG_STRING fmt, 'D', ## args)
#  define iti_printi(fmt) \
	printk (KERN_INFO LOG_STRING fmt, 'I')
#  define iti_printia(fmt,args...) \
	printk (KERN_INFO LOG_STRING fmt, 'I', ## args)
#  define iti_printn(fmt) \
	printk (KERN_NOTICE LOG_STRING fmt, 'N')
#  define iti_printna(fmt,args...) \
	printk (KERN_NOTICE LOG_STRING fmt, 'N', ## args)
#  define iti_printw(fmt) \
	printk (KERN_WARNING LOG_STRING fmt, 'W')
#  define iti_printwa(fmt,args...) \
	printk (KERN_WARNING LOG_STRING fmt, 'W', ## args)
#  define iti_printe(fmt) \
	printk (KERN_ERR LOG_STRING fmt, 'E')
#  define iti_printea(fmt,args...) \
	printk (KERN_ERR LOG_STRING fmt, 'E', ## args)
#  define iti_printr(fmt) printk (fmt)
#  define iti_printra(fmt,args...) printk (fmt, ## args)
  
#ifdef __OPTIMIZE__
#  define EXTERN extern  
#  define INLINE inline
#else
#  define EXTERN /**/ 
#  define INLINE /**/
#endif

EXTERN INLINE u_short
iti_readw (u_short *addr) 
#ifdef __OPTIMIZE__
{
  return readw (addr);
}
#else
;
#endif
EXTERN INLINE void
iti_writew (u_short value, u_short *addr)
#ifdef __OPTIMIZE__
{
  writew (value, addr);
}
#else
;
#endif
EXTERN INLINE u_long
iti_readl (u_long *addr) 
#ifdef __OPTIMIZE__
{
  return readl (addr);
}
#else
;
#endif
EXTERN INLINE void
iti_writel (u_long value, u_long *addr)
#ifdef __OPTIMIZE__
{
  writel (value, addr);
}
#else
;
#endif
EXTERN INLINE u_short
iti_inw (u_short port) 
#ifdef __OPTIMIZE__
{
  return inw (port);
}
#else
;
#endif
EXTERN INLINE void
iti_outw (u_short value, u_short port)
#ifdef __OPTIMIZE__
{
  outw (value, port);
}
#else
;
#endif
EXTERN INLINE u_long
iti_inl (u_short port) 
#ifdef __OPTIMIZE__
{
  return inl (port);
}
#else
;
#endif
EXTERN INLINE void
iti_outl (u_long value, u_short port)
#ifdef __OPTIMIZE__
{
  outl (value, port);
}
#else
;
#endif
EXTERN INLINE void*
iti_memset_io (void *dst, int val, size_t size)
#ifdef __OPTIMIZE__
{
#if defined(__alpha__) || defined (__ia64__)
  memset_io (dst, val, size);
  return NULL;
#else
  return memset_io (dst, val, size);
#endif
}
#else
;
#endif
EXTERN INLINE void
iti_udelay (u_long time)
#ifdef __OPTIMIZE__
{
  udelay (time);
}
#else
;
#endif

EXTERN INLINE void*
iti_memcpy (void* dst, const void* src, size_t size)
#ifdef __OPTIMIZE__
{
  return memcpy (dst, src, size);
}
#else
;
#endif
EXTERN INLINE void*
iti_memset (void* dst, int value, size_t size)
#ifdef __OPTIMIZE__
{
  return memset (dst, value, size);
}
#else
;
#endif
EXTERN INLINE char*
iti_strcpy (char* dst, const char* src)
#ifdef __OPTIMIZE__
{
  return strcpy (dst, src);
}
#else
;
#endif
EXTERN INLINE int
iti_strcmp (const char* dst, const char* src)
#ifdef __OPTIMIZE__
{
  return strcmp (dst, src);
}
#else
;
#endif

#if LINUX_VERSION_CODE < 0x020100

EXTERN INLINE int
iti_copyout (void *dst, void *src, size_t size)
#ifdef __OPTIMIZE__
{
  memcpy_tofs (dst, src, size);
  return 0;
}
#else
;
#endif
EXTERN INLINE int
iti_copyin (void *dst, const void *src, size_t size)
#ifdef __OPTIMIZE__
{
  memcpy_fromfs (dst, src, size);
  return 0;
}
#else
;
#endif

#elif LINUX_VERSION_CODE >= 0x020200

EXTERN INLINE int
iti_copyout (void *dst, void *src, size_t size)
#ifdef __OPTIMIZE__
{
  if (copy_to_user (dst, src, size))
    return -EFAULT;

  return 0;
}
#else
;
#endif
EXTERN INLINE int
iti_copyin (void *dst, const void *src, size_t size)
#ifdef __OPTIMIZE__
{
  if (copy_from_user (dst, src, size))
    return -EFAULT;

  return 0;
}
#else
;
#endif

#endif

#endif /* linux */

#ifdef __NetBSD__
#  define iti_printd(fmt) \
	printf (LOG_STRING fmt, 'D')
#  define iti_printda(fmt,args...) \
	printf (LOG_STRING fmt, 'D', ## args)
#  define iti_printi(fmt) \
	printf (LOG_STRING fmt, 'I')
#  define iti_printia(fmt,args...) \
	printf (LOG_STRING fmt, 'I', ## args)
#  define iti_printn(fmt) \
	printf (LOG_STRING fmt, 'N')
#  define iti_printna(fmt,args...) \
	printf (LOG_STRING fmt, 'N', ## args)
#  define iti_printw(fmt) \
	printf (LOG_STRING fmt, 'W')
#  define iti_printwa(fmt,args...) \
	printf (LOG_STRING fmt, 'W', ## args)
#  define iti_printe(fmt) \
	printf (LOG_STRING fmt, 'E')
#  define iti_printea(fmt,args...) \
	printf (LOG_STRING fmt, 'E', ## args)
#  define iti_printr(fmt) printk (fmt)
#  define iti_printra(fmt,args...) printk (fmt, ## args)
#ifdef __OPTIMIZE__
#  define EXTERN extern  
#  define INLINE inline
#else
#  define EXTERN /**/ 
#  define INLINE /**/
#endif

EXTERN INLINE void
iti_udelay (u_long time)
#ifdef __OPTIMIZE__
{
  delay (time);
}
#else
;
#endif

EXTERN INLINE void*
iti_memcpy (void* dst, const void* src, size_t size)
#ifdef __OPTIMIZE__
{
  return bcopy (src, dst, size);
}
#else
;
#endif
EXTERN INLINE void*
iti_memset (void* dst, int value, size_t size)
#ifdef __OPTIMIZE__
{
  if (value)
    return memset (dst, value, size);
  else
    return bzero (dst, size);
}
#else
;
#endif
EXTERN INLINE char*
iti_strcpy (char* dst, const char* src)
#ifdef __OPTIMIZE__
{
  return strcpy (dst, src);
}
#else
;
#endif
EXTERN INLINE int
iti_strcmp (const char* dst, const char* src)
#ifdef __OPTIMIZE__
{
  return strcmp (dst, src);
}
#else
;
#endif

EXTERN INLINE int
iti_copyout (void *dst, void *src, size_t size)
#ifdef __OPTIMIZE__
{
  return copyout (src, dst, size);
}
#else
;
#endif
EXTERN INLINE int
iti_copyin (void *dst, const void *src, size_t size)
#ifdef __OPTIMIZE__
{
  return copyin (src, dst, size);
}
#else
;
#endif

#endif /* __NetBSD__ */

#ifndef OS_DEFINED
#endif

#endif /* _ITIFGOS_H */

